SCREEN_WIDTH_BYTES      =       16      ;x-resolution in bytes
SCREEN_WIDTH_PIXELS     =       SCREEN_WIDTH_BYTES * 8
SCREEN_HEIGHT_RASTERS   =       94      ;y-resolution in lines
TV_STD_50HZ             =       312
TV_STD_60HZ             =       262
TV_STD                  =       TV_STD_50HZ
VSYNC_RASTERS           =       3
TOTAL_BLANK_RASTERS     =       TV_STD - 3 - SCREEN_HEIGHT_RASTERS - VSYNC_RASTERS
TOP_BLANK_RASTERS       =       TOTAL_BLANK_RASTERS / 2
BOTTOM_BLANK_RASTERS    =       TOTAL_BLANK_RASTERS - TOP_BLANK_RASTERS

FrameCounter    db      0

EnableHires:
        LD      HL,FRAMES               ;FRAMES counter
        LD      A,(HL)                  ;get old FRAMES
.Loop:
        CP      (HL)                    ;compare to new FRAMES
        JR      Z,.Loop                 ;exit after a change is detected
        LD      IX,WRX16                ;simple start of the hires mode
        RET

DisableHires:
        LD      A,$1E                   ;SINCLAIR ROM pattern table MSB base address (1E00)
        LD      I,A                     ;pointer to I register
        LD      IX,$0281                ;simple end of the hires mode
        RET

WRX16:
GenerateVsync:
        repeat 30
                nop
        end repeat                      ;syncronize the VSYNC-start
        in      a,($fe)                 ;VSYNC on, NMI off, HSYNC off
VsyncDelay:
        repeat 207 * VSYNC_RASTERS / 4
                nop
        end repeat
PrepareTopBorder:
        out     ($fe),a                 ;VSYNC off, NMI on, HSYNC on

        ld      a,256 - TOP_BLANK_RASTERS
        ex      af,af'
        ld      ix,GenerateHires
        pop     hl
        pop     de
        pop     bc
        pop     af
        ret                             ;return to do some useful work, and generate bottom blank lines

        align   32              ;needed
LineBuffer:
        ld      r,a             ;load hfile address lsb
        repeat SCREEN_WIDTH_BYTES
                nop
        end repeat
        ret     nz

GenerateHires:
        ld      b,7
        djnz    $                       ;delay to synchronize picture-start
        nop
        nop

        dec     b                       ;clear Z-flag
ScreenAddress = $ + 1
        ld      hl,SCREEN_0             ;start of hires-screen
        ld      de,SCREEN_WIDTH_BYTES
        ld      b,SCREEN_HEIGHT_RASTERS
HiresLines:
                ld      a,h
                ld      i,a
                ld      a,l
                repeat 8
                        nop
                end repeat
                call    LineBuffer+$8000;start generating the hires screen
                repeat 8
                        nop
                end repeat
                add     hl,de           ;point to next hires line
                dec     b
        jp      nz,HiresLines           ;repeat until last line is done
PrepareBottomBorder:
        ld      ix,GenerateVsync
field_set0:
        ld      a,256 - BOTTOM_BLANK_RASTERS
        ex      af,af'
        ld      hl,FrameCounter
        inc     (hl)
        out     ($fe),a                 ;NMI-generator on
        pop     hl
        pop     de
        pop     bc
        pop     af
        ret                             ;return to do some useful work, and generate bottom blank lines